/* 
 * minish 0.0.2.1 for Linux/8086 (ELKS kernel >=0.0.53)
 * (C) 1997 Chad Page et. al. 
 * 
 * Changelog:
 * 0.0.1 - Created
 * 0.0.2 - Procedurized by Stephan, hacked to work properly with 0.0.52 by Chad.
 * 0.0.2.1 - Modified to use POSIX-ish readdir calls (requires 0.0.53) - Chad
 */

#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <dirent.h>
#include <string.h>

/*#define DEBUG*/

char * genvp;

int getline(buf)
char * buf;
{
	int i = 0;

	read(1, buf, 1);
	write(0, buf, 1);
	while ((*buf != '\n') && (*buf != '\r')) {
		buf++; i++;
		if (read(1, buf, 1) != 1) {
			printf("Input stopped - oh oh...\n");
			fflush(stdout);
			while (1) {};
		}
		write(0, buf, 1);	/* Elks dunno how to echo */
	};
	*buf = '\0';
	return i;
}

void do_pwd()
{
char buf_pwd[128];

   if (getcwd(buf_pwd, 128) == NULL)
      {
      printf("error in getcwd!\n");
      fflush(stdout);
      }
   else
      {
      printf("%s\n", &buf_pwd);
      fflush(stdout);
      }
   
}

void do_ls (cmd_line)
char * cmd_line;
{
  DIR * directory;
  struct dirent direntry;

  if (cmd_line != NULL)
     {

#ifdef DEBUG
     printf("Before opendir cmd_line!\n");
     fflush(stdout);
#endif
     
     directory = opendir(cmd_line);
#ifdef DEBUG
     printf("After opendir cmd_line!\n");
     fflush(stdout);
#endif
     
     }
  else
     {
#ifdef DEBUG
     printf("before opendir . \n");
     fflush(stdout);
#endif
     
     directory = opendir(".");
#ifdef DEBUG
     printf("After opendir . \n");
     fflush(stdout);
#endif     
     }   

  while ((readdir(directory)) != 0)
  {
#ifdef DEBUG  
     printf("Before readdir! \n");
     fflush(stdout);
#endif     
     printf("%s\n", directory->dd_buf->d_name);
     fflush(stdout);
  }
  closedir(directory);
  
}


void do_chdir(new_dir)
char new_dir[30];
{

if (chdir(new_dir) < 0 )
   {
   printf("%s : no such file or directory\n", new_dir);
   fflush(stdout);
   }
   
}

void do_exec(buf2, buf)
char buf2[128], buf[128];
{
	int nr, stat, i, j;
	char *bufp[16], buf3[128];

	j = 1; buf3[0] = buf[0];
	for (i = 1; i < 127; i++) {
		if ((buf[i-1] != ' ') || (buf[i] != ' ')) {
			buf3[j] = buf[i]; j++;
		}
	} 

	if ((nr = fork())) {
		fflush(stdout);
		wait(&stat);
	} else {
		nr = 1; bufp[0] = buf3; 
		for (i = 1; buf3[i] != '\0'; i++) { 
			if (buf3[i] == ' ') {
				buf3[i] = '\0';
			}
			if (buf3[i - 1] == '\0') {
				bufp[nr] = &buf3[i]; nr++;
			}	
		}	
		execv(buf2, bufp, 0);  
		/* It didn't work :( */
		printf("%s: bad command or file name\n", buf2);
		fflush(stdout);
		exit(2);
	}

}

int parse(line)
char line[128];
{
	char buf2[128], buf3[128];
	int i, j;
	
		i = 0; 
		while ((line[i] != ' ') && (line[i] != '\0')) {
			buf2[i] = line[i];
			i++;
		};
		buf2[i] = '\0';
		
		j = 0;
		
		if (line[i] == ' ')
		   {
		     i++;
		     while ((line[i] != ' ') && (line[i] != '\0')) {
			     buf3[j] = line[i];
			     i++;
			     j++;
		     }
		   }  
		   
                buf3[j] = '\0';
                
		/* Start of parsing! */
		
		if (strcmp(buf2, "ls\0") ==0)
		   {
		   do_ls(NULL);
		   return 1;
		   }
		
		if (strcmp(buf2, "pwd\0") == 0)
		   {
		   do_pwd();
		   return 1;
		   }

		if (strcmp(buf2, "cd\0") ==0)
		   {
		   do_chdir(buf3);
		   return 1;
		   }
		   
		if ((i != 0) && (buf2[0] != '\n') && (buf2[0] != '\0'))
		   {
		   do_exec(buf2, line);
		   }
		else
		   {
		   return -1;
		   }   

}

void main(argc, argv, envp)
int argc;
char *argv[];
char *envp[];
{
	char buf[128];

	genvp = envp;

	printf("Welcome to Linux/8086 0.0.54.\n\n");
	fflush();

	while (1) {
	
		write(0, "# ", 2);	
		getline(buf);
		parse(buf);
		
	} /*end of while*/
}
