/*
 *	@(#)commands.c - Here are the commands functions
 *
 *	Copyright(c) 1997, Maurice Nonnekes <nonsens@dds.nl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>
#include <dirent.h>
#include <fcntl.h>

#include "commands.h"

void	command_cd( char *rest )
{
	if(chdir(rest) < 0)
		fprintf( stderr, "sh86: %s: No such file or directory\n", rest );
}

void	command_pwd( char *rest )
{
	char	buf[128];

	if(getcwd(buf, 128) == NULL)
		fprintf( stderr, "sh86: pwd: could not get directory\n" );
	else
		fprintf( stderr, "%s\n", buf );
}

void	command_ls( char *rest )
{
	DIR		*directory;
	struct dirent	direntry;

	if(rest == NULL)
		directory = opendir( "." );
	else
		directory = opendir( rest );

	if (directory == NULL) {
		fprintf(stderr, "Directory not found\n");
		return;
	}

	while( (readdir(directory)) != 0)
		fprintf( stderr, "%s\n", directory->dd_buf->d_name );

	closedir(directory);
}

void	command_mkdir( char *rest )
{
	if(mkdir(rest, 0777) < 0)
		fprintf( stderr, "mkdir: cannot make directory '%s'\n", rest );
}

void	command_rmdir( char *rest )
{
	if(rmdir(rest) < 0)
		fprintf( stderr, "rmdir: %s: could not remove directory\n", rest );
}

void	command_link( char *rest )
{
	char	*tmp;
	char	*realname;
	char	*linkname;

	realname = rest;
	if( (tmp = (char *) index(realname, ' ')) != (char *) 0)
	{
		*tmp++ = '\0';
		linkname = tmp;
	}

	symlink( realname, linkname );
}
