/*
 *	@(#)parse.c - The parsing stuff for sh86
 *
 *	Copyright(c) 1997, Maurice Nonnekes <nonsens@dds.nl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>

#include "commands.h"
#include "parse.h"

/* This piece of code is a refugee from minish, and it sets up the
 * stuff for execve correctly... */

void do_exec(buf2, buf)
char buf2[128], buf[128];
{
	int nr, stat, i, j;
	char *bufp[16], buf3[128];

	j = 1; buf3[0] = buf[0];
	for (i = 1; i < 127; i++) {
		if ((buf[i-1] != ' ') || (buf[i] != ' ')) {
			buf3[j] = buf[i]; j++;
		}
	} 

	if ((nr = fork())) {
		fflush(stdout);
		wait(&stat);
	} else {
		nr = 1; bufp[0] = buf3; 
		for (i = 1; buf3[i] != '\0'; i++) { 
			if (buf3[i] == ' ') {
				buf3[i] = '\0';
			}
			if (buf3[i - 1] == '\0') {
				bufp[nr] = &buf3[i]; nr++;
			}	
		}	
		execv(buf2, bufp, 0);  
		/* It didn't work :( */
		printf("%s: bad command or file name\n", buf2);
		fflush(stdout);
		exit(2);
	}

}

void	parse_command( char *buf )
{
	char	*command;
	char	*tmp, nbuf[123];
	int	i;
	int	num=0, proc_nr, proc_stat;
	int	fd;

	strcpy(nbuf, buf);

	command = buf;
	if( (tmp = (char *) index(command, ' ')) != (char *) 0)
	{
		*tmp++ = '\0';
	}

	for(i=0; commandfuns[i].type; i++)
	{
		if(!compare(commandfuns[i].type, command))
		{
			commandfuns[i].func( tmp );
			num=1;
			return;
		}
	}

	printf("%s %s\n", command, buf);
	do_exec(command, nbuf);
}

