/*
 *	@(#)sh86.c - A shell for Linux ELKS
 *
 *	Copyright(c) 1997, Maurice Nonnekes <nonsens@dds.nl>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdio.h>

void	wait_for_input(void)
{
	char	c = '\0';
	int	i = 0;
	char	buffer[512];
	char	*buf = buffer;

	while( (c != '\n') && (i < 511) )
	{
		if(read(1, &c, 1) != 1)
			fprintf( stderr, "sh86: Error while reading input.\n" );

		if(write(0, &c, 1) != 1)
			fprintf( stderr, "sh86: Error while writing output.\n" );

		buf[i] = c;
		i++;
	}

	buf[i-1] = '\0';

	parse_command( buf );
}

int	compare( register char *s1, register char *s2 )
{
	while((( (*s1) >= 'a' && (*s1) <= 'z') ? (*s1) - 32 : *s1 ) ==
	      (( (*s2) >= 'a' && (*s2) <= 'z') ? (*s2++) - 32 : *s2++ ))

	if(*s1++ == 0) return 0;
	return (*(unsigned char *)s1 - *(unsigned char *)-- s2);
}

int	main( int argc, char **argv )
{
	fprintf( stderr, "Shell 86 v0.0.55 - Copyright(c) 1997, Maurice Nonnekes\n\n" );

	while(1)
	{
		fprintf( stderr, "$ " );

		wait_for_input();
	}
}
